const fse = require('fs-extra');
const path = require('path');
const symbols = require('log-symbols')
const { log } = require('../util/log')
const chalk = require('chalk')
const config = {
  'listvue': 'src/renderer/page/manage/desk',
  'listjs': 'src/renderer/page/manage/desk',
  'reportvue': 'src/renderer/page/manage/diagnosis/operate/reportTemplate/structure',
  'reportjs': 'src/renderer/models/report/temp',
}

const configPath = path.resolve(__dirname,'../config.json')

async function defConfig() {
  try {
    await fse.outputJson(configPath, config)
  } catch (err) {
    console.error(err)
    process.exit()
  }
}

async function getJson () {
  try {
    const config = await fse.readJson(configPath)
    log.default(chalk.cyan('current config:'), config)
  } catch (err) {
    log.red(err)
  }
}

async function setUrl(name, link) {
  const exists = await fse.pathExists(configPath)
  if (exists){
    mirrorAction(name, link)
  }else{
    await defConfig()
    mirrorAction(name, link)
  }
}

async function mirrorAction(name, link){
  try {
    const config = await fse.readJson(configPath)
    config[name] = link
    await fse.writeJson(configPath, config)
    await getJson()
    console.log(symbols.success, '🚀 Set the mirror successful.')
  } catch (err) {
    console.log(symbols.error, chalk.red(`👻 Set the mirror failed. ${err}`))
    process.exit()
  }
}

module.exports = { setUrl, getJson, config}
